/*
  10-5-10
  Pete Dokter
  SparkFun Electronics
  
  This is an example sketch for Arduino that shows very basically how to control an Ardumoto
  motor driver shield with a 5V Arduino controller board (3.3V may work, but it's out of spec
  for the L298 H-bridge logic, so no promises). If you're plugging the Ardumoto into an
  Arduino Duemilanove or similar, all the connections are done for you and you can just rewrite
  the examples in this code to your liking.
  
  Changed to reflect a new board revision...
*/


//int pwm_a = 10;  //PWM control for motor outputs 1 and 2 is on digital pin 10
int pwm_a = 3;  //PWM control for motor outputs 1 and 2 is on digital pin 3
int pwm_b = 11;  //PWM control for motor outputs 3 and 4 is on digital pin 11
int dir_a = 12;  //direction control for motor outputs 1 and 2 is on digital pin 12
int dir_b = 13;  //direction control for motor outputs 3 and 4 is on digital pin 13

int ch_R = 2;    // audio channel R
int ch_L = 4;    // audio channel L

int mode = 5;    // iLj܂BluetoothiHj̐ؑ֗pfW^͔ԍ
int incomingByte=0;   // Mf[^p

unsigned int pR, pL;  // pXvpϐ


void setup()
{
  pinMode(pwm_a, OUTPUT);  //Set control pins to be outputs
  pinMode(pwm_b, OUTPUT);
  pinMode(dir_a, OUTPUT);
  pinMode(dir_b, OUTPUT);
  
  analogWrite(pwm_a, 100);  //set both motors to run at (100/255 = 39)% duty cycle (slow)
  analogWrite(pwm_b, 100);
  
  pinMode(ch_R, INPUT);    // E`l͐ݒ
  pinMode(ch_L, INPUT);    // `l͐ݒ
  pinMode(mode, INPUT);    // iLj܂BluetoothiHj̐ؑ
    
  Serial.begin(115200);      // BTڑɎgp
  
  digitalWrite(dir_a, LOW);  //Set motor direction, 1 low, 2 high
  digitalWrite(dir_b, LOW);  //Set motor direction, 3 high, 4 low
  analogWrite(pwm_a, 0);  
  analogWrite(pwm_b, 0);  
}

// MɂRg[
void AudioControl()
{
  pR=pulseIn(ch_R,HIGH,10000);
  pL=pulseIn(ch_L,HIGH,10000);
  
  if (pR !=0 ){
    if (pR<500) { digitalWrite(dir_a, LOW); } else {digitalWrite(dir_a, HIGH); }  
    analogWrite(pwm_a, 200);
  } else {analogWrite(pwm_a, 0); }
  
  if (pL !=0 ){
    if (pL<500) { digitalWrite(dir_b, LOW); } else {digitalWrite(dir_b, HIGH); }  
    analogWrite(pwm_b, 200);
  } else {analogWrite(pwm_b, 0); }
  
  delay(100);
}

// BluetoothɂRg[
void BluetoothControl()
{
  // L[͂̊mFC[^]
  if (Serial.available()>0){
    incomingByte=Serial.read();
    switch (incomingByte){
       case 'f': case 'F': digitalWrite(dir_a, LOW); digitalWrite(dir_b, LOW); analogWrite(pwm_a, 200); analogWrite(pwm_b, 200); break;
       case 'r': case 'R': digitalWrite(dir_a, HIGH); digitalWrite(dir_b, LOW); analogWrite(pwm_a, 0); analogWrite(pwm_b, 200); break;
       case 'l': case 'L': digitalWrite(dir_a, LOW); digitalWrite(dir_b, HIGH); analogWrite(pwm_a, 200); analogWrite(pwm_b, 0); break;
       case 'b': case 'B': digitalWrite(dir_a, HIGH); digitalWrite(dir_b, HIGH); analogWrite(pwm_a, 200); analogWrite(pwm_b, 200); break;
       case 's': case 'S': analogWrite(pwm_a, 0); analogWrite(pwm_b, 0); break;
    }
    // f,r,l,b ̎͂QbɎ~߂. F,R,L,B ̎̓A^CŔ
    if(incomingByte=='F' || incomingByte=='R' || incomingByte=='L' || incomingByte=='B'){
      delay(2000); analogWrite(pwm_a, 0); analogWrite(pwm_b, 0);
    }
  } 
}

void loop()
{
  if (digitalRead(mode)==LOW) AudioControl(); else BluetoothControl(); 
}
     
